<template>
  <VApp :dark="dark">
    <VToolbar
      v-if="header"
      :height="56"
      color="blue darken-3"
      dark
      app
    >
      <VExpandXTransition>
        <VToolbarTitle
          v-if="!btnSearch"
          class="text-uppercase"
        >
          <VIcon>list_alt</VIcon>
          Plano de contas
        </VToolbarTitle>
      </VExpandXTransition>

      <VSpacer v-if="!btnSearch" />

      <VTextField
        v-model="search"
        :class="!btnSearch && 'hidden-sm-and-down'"
        prepend-inner-icon="search"
        label="Procurar"
        flat
        solo-inverted
        clearable
        hide-details
        @focus="searchFocus = true"
        @blur="(search === null || search.length === 0) && (searchFocus = false)"
      />

      <VSpacer v-if="!btnSearch" />

      <VTooltip bottom>
        <template v-slot:activator="{ on }">
          <VBtn
            :class="!btnSearch && 'hidden-md-and-up'"
            large
            icon
            v-on="on"
            @click="btnSearch = !btnSearch"
          >
            <VIcon>{{ btnSearch ? 'close' : 'search' }}</VIcon>
          </VBtn>
        </template>
        <span>{{ btnSearch ? 'Fechar' : 'Buscar' }}</span>
      </VTooltip>

      <VExpandXTransition>
        <div
          v-show="!btnSearch"
          style="display: flex; height: 100%"
        >
          <VTooltip bottom>
            <template v-slot:activator="{ on }">
              <VBtn
                large
                icon
                @click="dark = !dark"
                v-on="on"
              >
                <VIcon>invert_colors</VIcon>
              </VBtn>
            </template>
            <span>Inverter a cor</span>
          </VTooltip>

          <VDivider
            class="mx-2"
            inset
            vertical
          />

          <VTooltip bottom>
            <template v-slot:activator="{ on }">
              <VBtn
                large
                icon
                href="https://gitlab.com/i.leonardo/ativ-crud-lar.app"
                target="_blank"
                v-on="on"
              >
                <img
                  src="@/assets/img/github/logo-light.png"
                  width="24px"
                >
              </VBtn>
            </template>
            <span>GitHub</span>
          </VTooltip>
        </div>
      </VExpandXTransition>
    </VToolbar>

    <VContent>
      <Nuxt v-if="!loading" />
    </VContent>

    <VFooter
      v-if="footer"
      class="px-3"
      color="blue darken-3"
      dark
      app
      absolute
    >
      Copyright © 2019 Leonardo C. Carvalho
      <VSpacer />
      Feito com muito amor&nbsp;<VIcon color="red">
        favorite
      </VIcon>
    </VFooter>

    <!-- message -->
    <VSnackbar
      v-model="snackbar"
      :color="msg.color"
      bottom
      multi-line
    >
      {{ msg.message }}
      <VBtn
        icon
        @click="snackbar = false"
      >
        <VIcon>close</VIcon>
      </VBtn>
    </VSnackbar>
  </VApp>
</template>

<script lang="ts">
import {
  Component, Vue, State, Mutation,
} from 'nuxt-property-decorator';

@Component
export default class Default extends Vue {
  @State
  msg!: {
    msg: string
    color: string
    bool: boolean
  }

  @State
  header!: boolean

  @State
  footer!: boolean

  @Mutation
  setHeader!: (key: boolean) => void

  @Mutation
  setFooter!: (key: boolean) => void

  @Mutation
  setBoolMsg!: (bool: boolean) => void

  @Mutation
  setSearchFocus!: (bool: boolean) => void

  @Mutation
  setSearch!: (key: string | null) => void

  loading = true

  dark = false

  btnSearch = false

  get snackbar() {
    return this.msg.bool;
  }

  set snackbar(bool) {
    this.setBoolMsg(bool);
  }

  get search(): string | null {
    return this.$store.state.search;
  }

  set search(key) {
    this.setSearch(key);
  }

  get searchFocus(): boolean {
    return this.$store.state.searchFocus;
  }

  set searchFocus(bool) {
    this.setSearchFocus(bool);
  }

  async mounted() {
    await this.$nextTick();

    this.$nuxt.$loading.start();
    this.setHeader(true);
    this.setFooter(true);
    this.loading = false;
    this.$nuxt.$loading.finish();
  }
}
</script>
